/****************************************************************/
/*  
     ***   ***  ***  *** ***     *** ***   ******  ****  ***
     ***   ***  ***  *** ***     *** **   ***  *** ***** ***
     ***   ***  ***  *** ***     *****    ******** *** *****
      *** ***   ***  *** ******* *** **   ***  *** ***  ****
       *****     *****   ******* *** ***  ***  *** ***   ***
	   
	 Vulkan Graphics API: in 20 Minutes (Coffee Break Series)
	 Beginners Taste

     Minimalistic examples to build upon and experiment with 
	 to develop an understanding of the underlying API
	   
/*
/****************************************************************/

#version 420


layout (binding = 1) uniform samplerCube samplerColor;

layout (location = 0) in vec3 inPos;
layout (location = 1) in vec3 inNormal;
layout (location = 2) in mat4 modelView;

layout (location = 0) out vec4 outFragColor;

void main() 
{
	vec3 cameraPos = vec3( modelView[0][0], modelView[0][1], modelView[0][2] );

	vec3 I = normalize(inPos - cameraPos);
    vec3 R = reflect(I, normalize(inNormal));
    vec4 refColor = texture(samplerColor, R);
	
	outFragColor = refColor;
}
